% lab16_ex_image_basics.m
% Image basics
clear all; close all; figure;

% Initialization - read image
[x,cmap] = imread('Friends.png');      % read image to "x", color palette to "cmap"
imshow(x,cmap), title('Image'); pause  % display image using its palette
[M, N] = size(x);                      % ask for number of rows and columns
x = double(x);                         % pixel values to double (gray scale)
MN = min(M,N); N=MN; x=x(1:N,1:N);     % reduce image to square matrix

% Observation of one image line
Num = 175; K = 2; y = x;                     % line number, marker width, copy
line = x(Num,1:N);                           % take one matrix row
y(Num-K:Num+K,1:N) = 0*ones(2*K+1,N);        % mark line with black color
figure;
subplot(121); imshow(y,cmap); title('Image');             % display image
subplot(122); plot(line); title('One line'); pause        % show one line
figure;
subplot(211); plot( abs(fft(line))/N ); title('|DFT|');        % line DFT
subplot(212); plot( dct(line)/sqrt(N) ); title('DCT'); pause   % line DCT
